#!/bin/bash

find -type d -name 't_*' -print | sort | cut -b3- | while read t; do
	echo "Running test [${t}]..."
	(
	cd "${t}"

	# Prepare stuff
	./pre.sh
	if [ "${?}" != "0" ]; then
		echo "Preparation for test [${t}] failed!"
		exit 1
	fi

	valgrind --tool=memcheck \
		--num-callers=16 \
		--leak-check=full \
		--db-attach=no \
		--show-reachable=yes \
		--trace-children=yes \
		--track-origins=yes \
	../../dupdump --verbose --debug --out test.out in &>test.log
	sort test.out > test.out2 && mv test.out2 test.out
	diff -u expected test.out > test.diff
	if [ "${?}" != "0" ]; then
		echo "Test [${t}] failed!"
		exit 1
	fi

	rm -f test.out test.diff
	)
done
